const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const dosageService = require('./dosage.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new dosage
 * @param {Object} req.body - The dosage data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created dosage
 */
function create(req, res, next) {
    dosageService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all dosages
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of dosages
 */
function getAll(req, res, next) {
    dosageService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of dosage objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of dosage objects
 */
function option(req, res, next) {
    dosageService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of dosages matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of dosages
 */
function count(req, res, next) {
    dosageService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing dosage
 * @param {number} req.params.id - The dosage ID to be updated
 * @param {Object} req.body - The dosage data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated dosage
 */
function update(req, res, next) {
    dosageService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a dosage
 * @param {number} req.params.id - The dosage ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    dosageService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
